#include "graphe.h"
#include "stoi.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include <assert.h>

void afficher(graphe_t* g){
	for (int i = 0; i < g->n; ++i)
	{
		printf("%s -> ", g->sommets[i]);
		adj_t* maillon = g->voisins[i];
		while (maillon != NULL){
			char* nom_voisin = g->sommets[maillon->dest];
			printf("(%s, %f), ", nom_voisin, maillon->poids);
			maillon = maillon->suiv;
		}
		printf("\n");
	}
}

bool est_arete(graphe_t* g, char* u, char* v){
	assert(stoi_mem(g->indice, u));
	assert(stoi_mem(g->indice, v));

	// retrouver les indices des sommets
	int i = stoi_get(g->indice, u);
	int j = stoi_get(g->indice, v);

	// chercher j dans la liste des voisins de i
	adj_t* maillon = g->voisins[i];
	while (maillon != NULL && maillon->dest != j){
		maillon = maillon->suiv;
	}
	// en sortie: soit maillon = NULL soit maillon représente une arête (i, j) 
	return (maillon != NULL);
}